Index: /data/media/levels/sample2.oxw
===================================================================
--- /data/media/levels/sample2.oxw	(revision 5254)
+++ /data/media/levels/sample2.oxw	(revision 5255)
@@ -15,9 +15,9 @@
    skybox       = "Orxonox/Starbox"
   >
-    <SpawnPoint position="0,   0,  100"           spawnclass=SpaceShip pawndesign=spaceshipassff />
+    <!--SpawnPoint position="0,   0,  100"           spawnclass=SpaceShip pawndesign=spaceshipassff />
     <SpawnPoint position="0,   0, -700" yaw  =180 spawnclass=SpaceShip pawndesign=spaceshipassff />
-    <SpawnPoint position="0, 300, -300" pitch=-90 spawnclass=SpaceShip pawndesign=spaceshipassff />
+    <SpawnPoint position="0, 300, -300" pitch=-90 spawnclass=SpaceShip pawndesign=spaceshipassff /-->
 
-    <MovableEntity position="0,0,-300" velocity="0,0,0" rotationaxis="0,1,0" rotationrate=90>
+    <MovableEntity scale=1.5 position="0,0,-300" velocity="0,0,0" rotationaxis="0,1,0" rotationrate=90>
       <attached>
         <Model position="0,0,0" scale=10 mesh="ast1.mesh" />
@@ -29,6 +29,14 @@
                 <Model position="0,35,0" scale=2 mesh="ast1.mesh" />
                 <Model position="0,-35,0" scale=2 mesh="ast1.mesh" />
-                <Model position="35,0,0" scale=2 mesh="ast1.mesh" />
-                <Model position="-35,0,0" scale=2 mesh="ast1.mesh" />
+                <Model position="35,0,0" scale=2 mesh="ast1.mesh">
+                  <attached>
+                    <ParticleEmitter position="0,0,0" source="Orxonox/fire3" />
+                  </attached>
+                </Model>
+                <Model position="-35,0,0" scale=2 mesh="ast1.mesh">
+                  <attached>
+                    <ParticleEmitter position="0,0,0" source="Orxonox/fire3" />
+                  </attached>
+                </Model>
               </attached>
             </MovableEntity>
@@ -37,4 +45,5 @@
         <MovableEntity position="0,0,-100" velocity="0,0,0" rotationaxis="0,1,0" rotationrate=200>
           <attached>
+            <ParticleEmitter position="0,0,0" source="Orxonox/fire3" />
             <Model position="0,0,0" scale=6 mesh="ast1.mesh" />
             <Model position="0,0,-50" scale=3 mesh="ast1.mesh" />
@@ -44,4 +53,18 @@
       </attached>
     </MovableEntity>
+
+    <ParticleSpawner position="-500,0,-200" source="Orxonox/BigExplosion1part1" lifetime=3.0 loop=1 />
+    <ParticleSpawner position="-500,0,-300" source="Orxonox/BigExplosion1part1" lifetime=3.0 loop=1 />
+    <ParticleSpawner position="-500,0,-400" source="Orxonox/BigExplosion1part1" lifetime=3.0 loop=1 />
+    <ParticleSpawner position="-500,0,-500" source="Orxonox/BigExplosion1part1" lifetime=2.5 loop=1 />
+    <ParticleSpawner position="-500,0,-600" source="Orxonox/BigExplosion1part1" lifetime=2.5 loop=1 />
+
+    <ParticleSpawner position="-500,200,-400" source="Orxonox/BigExplosion1part3" lifetime=2.0 loop=1 autostart=0>
+      <events>
+        <spawn>
+          <SpawnPoint position="0,0,100" spawnclass=SpaceShip pawndesign=spaceshipassff />
+        </spawn>
+      </events>
+    </ParticleSpawner>
 
     <Model position="0,0,200" scale=10 mesh="ast2.mesh" shadow=true />
Index: /data/media/levels/spaceshiptemplates.oxw
===================================================================
--- /data/media/levels/spaceshiptemplates.oxw	(revision 5254)
+++ /data/media/levels/spaceshiptemplates.oxw	(revision 5255)
@@ -17,6 +17,7 @@
       <Model position="0,0,0" yaw=90 pitch=-90 roll=0 scale=4 mesh="assff.mesh" />
       <!--Light position="0,0,20" diffuse="0,0,1" specular="0,0,1" type=point /-->
-      <BlinkingBillboard position="17,-1.5,0" material="Examples/Flare" colour="1.0, 0.5, 0.3" amplitude=0.1 frequency=0.5 />
-      <BlinkingBillboard position="-17,-1.5,0" material="Examples/Flare" colour="0.5, 1.0, 0.3" amplitude=0.1 frequency=0.5 phase=180 />
+      <BlinkingBillboard position="17,-1.5,0" material="Examples/Flare" colour="1.0, 0.5, 0.3" amplitude=0.1 frequency=0.5 quadratic=1 />
+      <BlinkingBillboard position="-17,-1.5,0" material="Examples/Flare" colour="0.5, 1.0, 0.3" amplitude=0.1 frequency=0.5 phase=180 quadratic=1 />
+      <!--ParticleEmitter position="0,0,-100" source="Orxonox/smoke5" /-->
     </attached>
   </SpaceShip>