Index: /trunk/configure.ac
===================================================================
--- /trunk/configure.ac	(revision 5278)
+++ /trunk/configure.ac	(revision 5279)
@@ -374,6 +374,4 @@
 # openGL #
 #--------#
-ac_save_LDFLAGS="${LDFLAGS}"
-
 # checking gl header
    AC_CHECK_HEADERS([GL/gl.h] ,,
@@ -381,5 +379,5 @@
 
 #  checking for Unix GL
-   AC_CHECK_LIB([GL], [main], [FOUND_GL=yes; LIBS="$LIBS -lGL"; LDFLAGS="${LDFLAGS} -lGL"])
+   AC_CHECK_LIB([GL], [main], [FOUND_GL=yes; LIBS="$LIBS -lGL"])
    if test x$FOUND_GL != xyes ; then
          echo "------------------"
@@ -414,6 +412,4 @@
          exit -1
    fi
-## resetting LD-flags as before GL
-LDFLAGS="${ac_save_LDFLAGS}"
 
 #--------#
@@ -480,4 +476,20 @@
 
    LIBS="$LIBS -framework OpenGL"
+
+
+
+# checking for GLEW-headers
+   AC_CHECK_HEADERS([GL/glew.h] ,,
+      [AC_MSG_ERROR([cannot find glew headers]) ])
+# checking for GLEW-lib
+  AC_CHECK_LIB([GLEW], [main], [FOUND_GLEW=yes; LIBS="$LIBS -lGLEW"])
+   if test x$FOUND_GLEW != xyes ; then
+         echo "------------------"
+         echo "glew not found."
+         echo "please install the glew package which can be found at http://glew.sourceforge.net"
+         echo "------------------"
+         exit -1
+   fi
+
 
    AC_CHECK_HEADERS([OpenAL/al.h] ,,
Index: /trunk/src/defs/glincl.h
===================================================================
--- /trunk/src/defs/glincl.h	(revision 5278)
+++ /trunk/src/defs/glincl.h	(revision 5279)
@@ -14,5 +14,5 @@
 #include <GL/glu.h>
 #else
-#include <OpenGL/glew.h>
+#include <GL/glew.h>
 #include <OpenGL/gl.h>
 #include <OpenGL/glu.h>
Index: /trunk/src/lib/collision_detection/bounding_volume.h
===================================================================
--- /trunk/src/lib/collision_detection/bounding_volume.h	(revision 5278)
+++ /trunk/src/lib/collision_detection/bounding_volume.h	(revision 5279)
@@ -25,7 +25,7 @@
 
     sVec3D* getVertices() const { return this->vertices; }
-    virtual void mergeWith(const BoundingVolume &bv) = NULL;
+    virtual void mergeWith(const BoundingVolume &bv) = 0;
 
-    virtual void drawBV(int currentDepth, int drawMode) const = NULL;
+    virtual void drawBV(int currentDepth, int drawMode) const = 0;
 
 
Index: /trunk/src/lib/collision_detection/bv_tree.h
===================================================================
--- /trunk/src/lib/collision_detection/bv_tree.h	(revision 5278)
+++ /trunk/src/lib/collision_detection/bv_tree.h	(revision 5279)
@@ -39,11 +39,11 @@
   virtual ~BVTree();
 
-  virtual void spawnBVTree(int depth, sVec3D *verticesList, const int length) = NULL;
-  virtual void flushTree() = NULL;
+  virtual void spawnBVTree(int depth, sVec3D *verticesList, const int length) = 0;
+  virtual void flushTree() = 0;
 
-  virtual void collideWith(BVTree* tree, WorldEntity* nodeA, WorldEntity* nodeB) = NULL;
-  virtual void collideWith(WorldEntity* entity1, WorldEntity* entity2) = NULL;
+  virtual void collideWith(BVTree* tree, WorldEntity* nodeA, WorldEntity* nodeB) = 0;
+  virtual void collideWith(WorldEntity* entity1, WorldEntity* entity2) = 0;
 
-  virtual void drawBV(int depth, int drawMode) const = NULL;
+  virtual void drawBV(int depth, int drawMode) const = 0;
 
 
Index: /trunk/src/lib/collision_detection/bv_tree_node.h
===================================================================
--- /trunk/src/lib/collision_detection/bv_tree_node.h	(revision 5278)
+++ /trunk/src/lib/collision_detection/bv_tree_node.h	(revision 5279)
@@ -25,12 +25,12 @@
   virtual ~BVTreeNode();
 
-  virtual void spawnBVTree(const int depth, sVec3D *verticesList, const int length ) = NULL;
+  virtual void spawnBVTree(const int depth, sVec3D *verticesList, const int length ) = 0;
 
-  virtual BoundingVolume* getBV(int index) const = NULL;
+  virtual BoundingVolume* getBV(int index) const = 0;
   inline const int getIndex() { return this->treeIndex; }
 
-  virtual void collideWith(BVTreeNode* treeNode, WorldEntity* nodeA, WorldEntity* nodeB) = NULL;
+  virtual void collideWith(BVTreeNode* treeNode, WorldEntity* nodeA, WorldEntity* nodeB) = 0;
 
-  virtual void drawBV(int depth, int drawMode) = NULL;
+  virtual void drawBV(int depth, int drawMode) = 0;
 
 
Index: /trunk/src/lib/event/event_listener.h
===================================================================
--- /trunk/src/lib/event/event_listener.h	(revision 5278)
+++ /trunk/src/lib/event/event_listener.h	(revision 5279)
@@ -21,5 +21,5 @@
    * @param event: the event
   */
-  virtual void process(const Event &event) = NULL;
+  virtual void process(const Event &event) = 0;
 };
 
Index: /trunk/src/lib/graphics/render2D/element_2d.h
===================================================================
--- /trunk/src/lib/graphics/render2D/element_2d.h	(revision 5278)
+++ /trunk/src/lib/graphics/render2D/element_2d.h	(revision 5279)
@@ -177,5 +177,5 @@
   public:
     virtual void tick(float dt);
-    virtual void draw() const = NULL;
+    virtual void draw() const = 0;
 
   private:
Index: /trunk/src/lib/lang/base_object.h
===================================================================
--- /trunk/src/lib/lang/base_object.h	(revision 5278)
+++ /trunk/src/lib/lang/base_object.h	(revision 5279)
@@ -12,5 +12,5 @@
 #include "class_id.h"
 #ifndef NULL
-#define NULL 0x0        //!< NULL
+#define NULL     0    //!< NULL
 #endif
 
Index: /trunk/src/lib/shell/shell_command.h
===================================================================
--- /trunk/src/lib/shell/shell_command.h	(revision 5278)
+++ /trunk/src/lib/shell/shell_command.h	(revision 5279)
@@ -106,5 +106,5 @@
   private:
     /** executes a Command @param object the object to apply this to @param parameters the parameters the command takes */
-    virtual void executeCommand (BaseObject* object, const char* parameters) = NULL;
+    virtual void executeCommand (BaseObject* object, const char* parameters) = 0;
 
   protected:
Index: /trunk/src/lib/sound/ogg_player.h
===================================================================
--- /trunk/src/lib/sound/ogg_player.h	(revision 5278)
+++ /trunk/src/lib/sound/ogg_player.h	(revision 5279)
@@ -13,5 +13,5 @@
 #include "base_object.h"
 
-#include <AL/al.h>
+#include "alincl.h"
 #include <ogg/ogg.h>
 #include <vorbis/vorbisfile.h>
Index: /trunk/src/lib/sound/sound_engine.cc
===================================================================
--- /trunk/src/lib/sound/sound_engine.cc	(revision 5278)
+++ /trunk/src/lib/sound/sound_engine.cc	(revision 5279)
@@ -60,6 +60,6 @@
   /* according to http://www.edenwaith.com/products/pige/tutorials/openal.php the alutLoadWAVFile differs from platform to platform*/
 #ifdef __APPLE__
-  alutLoadWAVFile(fileName, &format, &data, &this->size, &freq);
-#elifdef __WIN32__
+  alutLoadWAVFile((ALbyte*)fileName, &format, &data, &this->size, &freq);
+#elif defined __WIN32__
   alutLoadWAVFile(fileName, &format, &data, &size, &freq, &this->loop);
 #else
Index: /trunk/src/util/fast_factory.h
===================================================================
--- /trunk/src/util/fast_factory.h	(revision 5278)
+++ /trunk/src/util/fast_factory.h	(revision 5279)
@@ -83,5 +83,5 @@
 
     /** generates a new Object of the Class T */
-    virtual void fabricate() = NULL;
+    virtual void fabricate() = 0;
 
   private:
Index: /trunk/src/util/loading/load_param.h
===================================================================
--- /trunk/src/util/loading/load_param.h	(revision 5278)
+++ /trunk/src/util/loading/load_param.h	(revision 5279)
@@ -307,5 +307,5 @@
     {
       const TiXmlElement* elem = root->FirstChildElement(paramName);
-      if (likely(elem != NULL))
+      if (elem != NULL)
         (*pt2Object.*function)(elem);
       else